﻿using System;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using Telerik.Storage.Extensions;

namespace IndicesPerformanceTestApp.Domain
{
    /// <summary>
    /// Table will be implicitly indexed by ID column
    /// </summary>
    class Person
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public long ID { get; set; }

        public string Name { get; set; }
        public int Age { get; set; }

        public DateTime BornDate { get; set; }
        public int PersonHeight { get; set; }
    }

    class IndexedPerson
    {
        [Key]
        [DatabaseGenerated(DatabaseGeneratedOption.Identity)]
        public long ID { get; set; }

        [DatabaseIndex("NameIdx", SortOrder.Asc, 0, false)]
        [DatabaseIndex("ComplexIdx", SortOrder.Asc, 0, false)] //REMARK: if you comment this row, to check the query with bad index, 
        public string Name { get; set; }                       //you should remove the app in order to refill tables and recreate indexes

        [DatabaseIndex("ComplexIdx", SortOrder.Asc, 1, false)]
        public int Age { get; set; }

        public DateTime BornDate { get; set; }

        [DatabaseIndex("ComplexIdx", SortOrder.Asc, 2, false)]
        public int PersonHeight { get; set; }
    }



}
