﻿using IndicesPerformanceTestApp.Common;
using IndicesPerformanceTestApp.Models;
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace IndicesPerformanceTestApp.ViewModels
{
    class MainPageViewModel : BindableBase
    {
        public MainPageViewModel()
        {
            storage = new MainPageModel();

            //check the fill state of tables
            try
            {
                long recordsCount;
                storage.RunQuery("Select * from IndexedPerson Where Name = 'Person Name 1'", true, out recordsCount);
                IsIndexedTableFilled = recordsCount != 0;

                storage.RunQuery("Select * from Person Where Name = 'Person Name 1'", true, out recordsCount);
                IsNonIndexedTableFilled = recordsCount != 0;
            }
            catch (Exception) //tables doesn't exist 
            {
                IsIndexedTableFilled = IsNonIndexedTableFilled = false;
            }
                 
            //fill in data queries
            this.EQIDCommand_1 = new DelegateCommand(EQIDCommandExecute_1, EQIDCommandCanExecute_1);
            this.EQNIDCommand_1 = new DelegateCommand(EQNIDCommandExecute_1, EQNIDCommandCanExecute_1);

            this.EQIDCommand_2 = new DelegateCommand(EQIDCommandExecute_2, EQIDCommandCanExecute);
            this.EQNIDCommand_2 = new DelegateCommand(EQNIDCommandExecute_2, EQNIDCommandCanExecute);

            this.EQIDCommand_3 = new DelegateCommand(EQIDCommandExecute_3, EQIDCommandCanExecute);
            this.EQNIDCommand_3 = new DelegateCommand(EQNIDCommandExecute_3, EQNIDCommandCanExecute);

            this.EQIDCommand_4 = new DelegateCommand(EQIDCommandExecute_4, EQIDCommandCanExecute);
            this.EQNIDCommand_4 = new DelegateCommand(EQNIDCommandExecute_4, EQNIDCommandCanExecute);

            this.EQIDCommand_5 = new DelegateCommand(EQIDCommandExecute_5, EQIDCommandCanExecute);
            this.EQNIDCommand_5 = new DelegateCommand(EQNIDCommandExecute_5, EQNIDCommandCanExecute);

            this.EQIDCommand_6 = new DelegateCommand(EQIDCommandExecute_6, EQIDCommandCanExecute);
            this.EQNIDCommand_6 = new DelegateCommand(EQNIDCommandExecute_6, EQNIDCommandCanExecute);

            this.EQIDCommand_7 = new DelegateCommand(EQIDCommandExecute_7, EQIDCommandCanExecute);
            this.EQNIDCommand_7 = new DelegateCommand(EQNIDCommandExecute_7, EQNIDCommandCanExecute);
        }

        MainPageModel storage;

        public bool IsIndexedTableFilled { get; set; }
        public bool IsNonIndexedTableFilled { get; set; }

        #region Command Properties
        /// <summary>
        /// Properties for elapsed time of sql queries
        /// </summary>
        private string eqidCommandElapsedTime_1;
        public string EQIDCommandElapsedTime_1
        {
            get { return eqidCommandElapsedTime_1; }
            set
            {
                SetProperty<string>(ref this.eqidCommandElapsedTime_1, value);
            }
        }

        private string eqnidCommandElapsedTime_1;
        public string EQNIDCommandElapsedTime_1
        {
            get { return eqnidCommandElapsedTime_1; }
            set
            {
                SetProperty<string>(ref this.eqnidCommandElapsedTime_1, value);
            }
        }

        //properties for second command
        private string eqidCommandElapsedTime_2;
        public string EQIDCommandElapsedTime_2
        {
            get { return eqidCommandElapsedTime_2; }
            set
            {
                SetProperty<string>(ref this.eqidCommandElapsedTime_2, value);
            }
        }

        private string eqnidCommandElapsedTime_2;
        public string EQNIDCommandElapsedTime_2
        {
            get { return eqnidCommandElapsedTime_2; }
            set
            {
                SetProperty<string>(ref this.eqnidCommandElapsedTime_2, value);
            }
        }

        //properties for third command
        private string eqidCommandElapsedTime_3;
        public string EQIDCommandElapsedTime_3
        {
            get { return eqidCommandElapsedTime_3; }
            set
            {
                SetProperty<string>(ref this.eqidCommandElapsedTime_3, value);
            }
        }

        private string eqnidCommandElapsedTime_3;
        public string EQNIDCommandElapsedTime_3
        {
            get { return eqnidCommandElapsedTime_3; }
            set
            {
                SetProperty<string>(ref this.eqnidCommandElapsedTime_3, value);
            }
        }


        //properties for fourth command
        private string eqidCommandElapsedTime_4;
        public string EQIDCommandElapsedTime_4
        {
            get { return eqidCommandElapsedTime_4; }
            set
            {
                SetProperty<string>(ref this.eqidCommandElapsedTime_4, value);
            }
        }

        private string eqnidCommandElapsedTime_4;
        public string EQNIDCommandElapsedTime_4
        {
            get { return eqnidCommandElapsedTime_4; }
            set
            {
                SetProperty<string>(ref this.eqnidCommandElapsedTime_4, value);
            }
        }

        //properties for fifth command
        private string eqidCommandElapsedTime_5;
        public string EQIDCommandElapsedTime_5
        {
            get { return eqidCommandElapsedTime_5; }
            set
            {
                SetProperty<string>(ref this.eqidCommandElapsedTime_5, value);
            }
        }

        private string eqnidCommandElapsedTime_5;
        public string EQNIDCommandElapsedTime_5
        {
            get { return eqnidCommandElapsedTime_5; }
            set
            {
                SetProperty<string>(ref this.eqnidCommandElapsedTime_5, value);
            }
        }


        //properties for sixth command
        private string eqidCommandElapsedTime_6;
        public string EQIDCommandElapsedTime_6
        {
            get { return eqidCommandElapsedTime_6; }
            set
            {
                SetProperty<string>(ref this.eqidCommandElapsedTime_6, value);
            }
        }

        private string eqnidCommandElapsedTime_6;
        public string EQNIDCommandElapsedTime_6
        {
            get { return eqnidCommandElapsedTime_6; }
            set
            {
                SetProperty<string>(ref this.eqnidCommandElapsedTime_6, value);
            }
        }

        //properties for seventh command
        private string eqidCommandElapsedTime_7;
        public string EQIDCommandElapsedTime_7
        {
            get { return eqidCommandElapsedTime_7; }
            set
            {
                SetProperty<string>(ref this.eqidCommandElapsedTime_7, value);
            }
        }

        private string eqnidCommandElapsedTime_7;
        public string EQNIDCommandElapsedTime_7
        {
            get { return eqnidCommandElapsedTime_7; }
            set
            {
                SetProperty<string>(ref this.eqnidCommandElapsedTime_7, value);
            }
        }

        #endregion Command Properties

        #region Commands
        /// <summary>
        /// Commands for Telerik Data Storage tests
        /// EQI = Execute Query on Indexed Data
        /// EQNI= Execute Query on Non Indexed Data
        /// </summary>
        public IDelegateCommand EQIDCommand_1 { protected set; get; }
        public IDelegateCommand EQNIDCommand_1 { protected set; get; }

        private void EQIDCommandExecute_1(object param)
        {
            if (!IsIndexedTableFilled)
            {
                double retMS = storage.CreateAndFillDB(true);

                EQIDCommandElapsedTime_1 = retMS.ToString() + " ms for 30 000 records inserted";
                IsIndexedTableFilled = true;

                EQIDCommand_1.RaiseCanExecuteChanged();
                EQIDCommand_2.RaiseCanExecuteChanged();
                EQIDCommand_3.RaiseCanExecuteChanged();
                EQIDCommand_4.RaiseCanExecuteChanged();
                EQIDCommand_5.RaiseCanExecuteChanged();
                EQIDCommand_6.RaiseCanExecuteChanged();
                EQIDCommand_7.RaiseCanExecuteChanged();
            }
        }

        private bool EQIDCommandCanExecute_1(object param)
        {
            return !IsIndexedTableFilled;
        }

        private void EQNIDCommandExecute_1(object param)
        {
            if (!IsNonIndexedTableFilled)
            {
                double retMS = storage.CreateAndFillDB(false);

                EQNIDCommandElapsedTime_1 = retMS.ToString() + " ms for 30 000 records inserted";
                IsNonIndexedTableFilled = true;

                EQNIDCommand_1.RaiseCanExecuteChanged();
                EQNIDCommand_2.RaiseCanExecuteChanged();
                EQNIDCommand_3.RaiseCanExecuteChanged();
                EQNIDCommand_4.RaiseCanExecuteChanged();
                EQNIDCommand_5.RaiseCanExecuteChanged();
                EQNIDCommand_6.RaiseCanExecuteChanged();
                EQNIDCommand_7.RaiseCanExecuteChanged();
            }
        }

        private bool EQNIDCommandCanExecute_1(object param)
        {
            return !IsNonIndexedTableFilled;
        }

        
        /// <summary>
        /// second group of commands - The power of simple index
        /// </summary>
        public IDelegateCommand EQIDCommand_2 { protected set; get; }
        public IDelegateCommand EQNIDCommand_2 { protected set; get; }

        private void EQIDCommandExecute_2(object param)
        {
            if (IsIndexedTableFilled)
            {
                long recordsCount;
                string query = "Select * from IndexedPerson where Name = 'Person Name 4505'";
                double retMS = storage.RunQuery(query, true, out recordsCount);
                EQIDCommandElapsedTime_2 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }

        private void EQNIDCommandExecute_2(object param)
        {
            if (IsNonIndexedTableFilled)
            {
                long recordsCount;
                string query = "Select * from Person where Name = 'Person Name 4505'";
                double retMS = storage.RunQuery(query, false, out recordsCount);
                EQNIDCommandElapsedTime_2 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }

        private bool EQIDCommandCanExecute(object param)
        {
            return IsIndexedTableFilled;
        }

        private bool EQNIDCommandCanExecute(object param)
        {
            return IsNonIndexedTableFilled;
        }


        /// <summary>
        /// third group of commands - ComplexIDX index used by engine. Mixed order doesn't matter in case of AND operator
        /// </summary>
        public IDelegateCommand EQIDCommand_3 { protected set; get; }
        public IDelegateCommand EQNIDCommand_3 { protected set; get; }

        private void EQIDCommandExecute_3(object param)
        {
            if (IsIndexedTableFilled)
            {
                long recordsCount;
                string query = "SELECT * FROM IndexedPerson WHERE Name = 'Person Name 4950' AND Age == 30 AND PersonHeight == 170";
                //string query = "SELECT * FROM IndexedPerson WHERE Age == 30 AND PersonHeight == 170 AND Name = 'Person Name 4950'"; //uncomment to check the mixed order of index
                double retMS = storage.RunQuery(query, true, out recordsCount);
                EQIDCommandElapsedTime_3 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }

        private void EQNIDCommandExecute_3(object param)
        {
            if (IsNonIndexedTableFilled)
            {
                long recordsCount;
                string query = "SELECT * FROM Person WHERE Name = 'Person Name 4950' AND Age == 30 AND PersonHeight == 170";
                //string query = "SELECT * FROM Person WHERE Age == 30 AND PersonHeight == 170 AND Name = 'Person Name 4950'"; //uncomment to check the mixed order of index
                double retMS = storage.RunQuery(query, false, out recordsCount);
                EQNIDCommandElapsedTime_3 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }


        /// <summary>
        /// fourth group of commands - Wrongly configured index, remove the "Name" filed for better results
        /// </summary>
        public IDelegateCommand EQIDCommand_4 { protected set; get; }
        public IDelegateCommand EQNIDCommand_4 { protected set; get; }

        //REMARK: this query uses non well tuned index ComplexIdx, and as is described in document to check the behavior
        // you should remove from this index the field "Name" of IndexedPerson table .
        private void EQIDCommandExecute_4(object param)
        {
            if (IsIndexedTableFilled)
            {
                long recordsCount;
                string query = "SELECT * FROM IndexedPerson WHERE Age == 30 AND PersonHeight == 170";
                double retMS = storage.RunQuery(query, true, out recordsCount);
                EQIDCommandElapsedTime_4 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }

        private void EQNIDCommandExecute_4(object param)
        {
            if (IsNonIndexedTableFilled)
            {
                long recordsCount;
                string query = "SELECT * FROM Person WHERE Age == 30 AND PersonHeight == 170";
                double retMS = storage.RunQuery(query, false, out recordsCount);
                EQNIDCommandElapsedTime_4 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }


        /// <summary>
        /// fifth group of commands - Indices doesn't help at all in case of OR
        /// </summary>
        public IDelegateCommand EQIDCommand_5 { protected set; get; }
        public IDelegateCommand EQNIDCommand_5 { protected set; get; }

        private void EQIDCommandExecute_5(object param)
        {
            if (IsIndexedTableFilled)
            {
                long recordsCount;
                string query = "SELECT * FROM IndexedPerson WHERE Age == 30 OR PersonHeight == 170";
                double retMS = storage.RunQuery(query, true, out recordsCount);
                EQIDCommandElapsedTime_5 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }

        private void EQNIDCommandExecute_5(object param)
        {
            if (IsNonIndexedTableFilled)
            {
                long recordsCount;
                string query = "SELECT * FROM Person WHERE Age == 30 OR PersonHeight == 170";
                double retMS = storage.RunQuery(query, false, out recordsCount);
                EQNIDCommandElapsedTime_5 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }


        /// <summary>
        /// sixth group of commands - Index is not used in case of OR
        /// </summary>
        public IDelegateCommand EQIDCommand_6 { protected set; get; }
        public IDelegateCommand EQNIDCommand_6 { protected set; get; }

        private void EQIDCommandExecute_6(object param)
        {
            if (IsIndexedTableFilled)
            {
                long recordsCount;
                string query = "SELECT * FROM IndexedPerson WHERE Name = 'Person Name 4950' AND Age == 30 OR PersonHeight == 170";
                double retMS = storage.RunQuery(query, true, out recordsCount);
                EQIDCommandElapsedTime_6 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }

        private void EQNIDCommandExecute_6(object param)
        {
            if (IsNonIndexedTableFilled)
            {
                long recordsCount;
                string query = "SELECT * FROM Person WHERE Name = 'Person Name 4950' AND Age == 30 OR PersonHeight == 170";
                double retMS = storage.RunQuery(query, false, out recordsCount);
                EQNIDCommandElapsedTime_6 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }


        /// <summary>
        /// sixth group of commands - The importance of groping of OR clauses in parеnthesis
        /// </summary>
        public IDelegateCommand EQIDCommand_7 { protected set; get; }
        public IDelegateCommand EQNIDCommand_7 { protected set; get; }

        private void EQIDCommandExecute_7(object param)
        {
            if (IsIndexedTableFilled)
            {
                long recordsCount;
                string query = "SELECT * FROM IndexedPerson WHERE Name = 'Person Name 4950' AND (Age == 30 OR PersonHeight == 170)";
                double retMS = storage.RunQuery(query, true, out recordsCount);
                EQIDCommandElapsedTime_7 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }

        private void EQNIDCommandExecute_7(object param)
        {
            if (IsNonIndexedTableFilled)
            {
                long recordsCount;
                string query = "SELECT * FROM Person WHERE Name = 'Person Name 4950' AND (Age == 30 OR PersonHeight == 170)";
                double retMS = storage.RunQuery(query, false, out recordsCount);
                EQNIDCommandElapsedTime_7 = retMS.ToString() + " ms for " + recordsCount.ToString() + " records found";
            }
        }


        #endregion Comands


    }
}
